<template>
  <div class="q-pa-md">
    <div>
      <h1>  Query EoX API by dates </h1>

      <div class="row">
        <div class="col-sm-3 col-12">
          <q-input outlined stack-label
                   v-model="startDate"
                   color="indigo-8"
                   label="Start Date"
                   mask="####-##-##"
                   hint="YYYY-MM-DD" />
        </div>
        <div class="col-sm-1 col-12">
        </div>
        <div class="col-sm-3 col-12">
          <q-input  outlined stack-label
                   v-model="endDate"
                    color="indigo-8"
                    label="End Date"
                    mask="####-##-##"
                    hint="YYYY-MM-DD" />
        </div>
      </div>

      <div class="row">
        <div class="col-sm-3 col-12 text-white">
          <span >. </span>
        </div>
      </div>

      <div class="row">
        <div class="col-sm-3 col-12">
          <q-input outlined stack-label
                   v-model="pageIndex"
                   color="indigo-8"
                   label="Page Index"
                   hint="Requested page (defaults to 1)" />
        </div>
        <div class="col-sm-1 col-12">
        </div>
        <div class="col-sm-3 col-12">
          <q-select  outlined stack-label
                     v-model="eoxAttrib"
                     :options="eoxAttribOptions"
                     color="indigo-8"
                     label="EoX Attribute"
                     hint="What EoX date should be matched?"
                     :options-dense=true />
        </div>
      </div>
    </div>

    <div class="actions" align="right" style="max-width: 130px">
        <q-btn color="light-blue-4" @click="fetchData">
          <q-icon size="2em" name="youtube_searched_for" />
          <div>Search</div>
        </q-btn>
    </div>


    <div class="q-pa-md" v-show="EOXRecordTableData.length">
      <q-banner rounded dense class="bg-light-blue-4 text-white q-pa-md" >
        <b>EOXByDates returned:  </b>{{PaginationResponseRecord.TotalRecords}} record(s) & {{PaginationResponseRecord.LastIndex}} page(s) <br>
        <i>(Exhibiting page {{PaginationResponseRecord.PageIndex}} containing {{PaginationResponseRecord.PageRecords}} records)</i>.
        <template v-slot:action>
          <q-chip dense clickable @click="downloadFile(EOXFileName + '.json')" icon="save_alt">.json </q-chip>
          <q-chip dense clickable @click="downloadFile(EOXFileName + '.csv')" icon="save_alt">.csv</q-chip>
        </template>
      </q-banner>
      <div class="q-pa-md" >
        <q-table
          title="EoX Records"
          :columns="EoXRecordTableColumns"
          :data="EOXRecordTableData"
          :rows-per-page-options="[15]"
        />
      </div>
    </div>

    <div class="q-pa-md" v-show="EOXErrorsData.length">
      <q-banner rounded dense class="bg-red-2 text-black q-pa-md">
        <b>EOXByDates returned error record(s):  </b><br><p v-html="EOXErrorsData"></p>
      </q-banner>
    </div>

  </div>
</template>

<script>
export default {
  data() {
    return {
      showEOXTable: false,
      startDate: null,
      endDate: null,
      pageIndex: 1,
      eoxAttrib: 'EO_SALES_DATE',
      eoxAttribOptions: [
        'EO_SALES_DATE',
        'EO_EXT_ANNOUNCE_DATE',
        'EO_FAIL_ANALYSIS_DATE',
        'EO_SVC_ATTACH_DATE',
        'EO_SW_MAINTENANCE_DATE',
        'EO_SECURITY_VUL_SUPPORT_DATE',
        'EO_CONTRACT_RENEW_DATE',
        'EO_LAST_SUPPORT_DATE',
        'UPDATE_TIMESTAMP'],
      PaginationResponseRecord: {
        TotalRecords: 0,
        LastIndex: 0,
        PageIndex: 0,
        PageRecords: 0
      },
      EOXRecord: null,
      EOXRecordTableData: [],
      EoXRecordTableColumns: [
        {
          name: "EOLProductID",
          label: "EOLProductID",
          field: "EOLProductID",
          sortable: true
        },
        {
          name: "ProductIDDescription",
          label: "ProductIDDescription",
          field: "ProductIDDescription",
        },
        {
          name: "EOXExternalAnnouncementDate",
          label: "EOXExternalAnnouncementDate",
          field: "EOXExternalAnnouncementDate",
        },
        {
          name: "EndOfSaleDate",
          label: "EndOfSaleDate",
          field: "EndOfSaleDate",
        },
        {
          name: "EndOfSWMaintenanceReleases",
          label: "EndOfSWMaintenanceReleases",
          field: "EndOfSWMaintenanceReleases",
        },
        {
          name: "EndOfSecurityVulSupportDate",
          label:"EndOfSecurityVulSupportDate",
          field: "EndOfSecurityVulSupportDate",
        },
        {
          name: "EndOfRoutineFailureAnalysisDate",
          label:"EndOfRoutineFailureAnalysisDate",
          field: "EndOfRoutineFailureAnalysisDate",
        },
        {
          name:  "EndOfServiceContractRenewal",
          label: "EndOfServiceContractRenewal",
          field:  "EndOfServiceContractRenewal",
        },
        {
          name:  "LastDateOfSupport",
          label: "LastDateOfSupport",
          field:  "LastDateOfSupport",
        },
        {
          name:  "EndOfSvcAttachDate",
          label: "EndOfSvcAttachDate",
          field: "EndOfSvcAttachDate",
        },
        {
          name:  "MigrationInformation",
          label: "MigrationInformation",
          field: "MigrationInformation",
          sortable: false
        },
        {
          name:  "MigrationOption",
          label: "MigrationOption",
          field:  "MigrationOption",
          sortable: false
        },
        {
          name: "MigrationProductId",
          label:"MigrationProductId",
          field:  "MigrationProductId",
          sortable: false
        },
        {
          name:  "MigrationProductName",
          label: "MigrationProductName",
          field:   "MigrationProductName",
          sortable: false
        }
      ],
      EOXErrorsData: '',
      EOXFileName: ''
    }
  },
  methods: {
    fetchData() {
      this.EOXRecord = null;
      this.EOXRecordTableData = [];
      this.EOXErrorsData = '';
      this.EOXFileName = '';
      this.$q.loading.show();
      const url = `EOXByDates?pageIndex=${this.pageIndex}&startDate=${this.startDate}&endDate=${this.endDate}&eoxAttrib=${this.eoxAttrib}`
      this.$axios.get(url)
        .then(response => {
          console.log(response)
          if ('EOXError' in response.data){
            this.EOXErrorsData = response.data.EOXError.ErrorID + ": " + response.data.EOXError.ErrorDescription
          }
          else{
            this.EOXFileName = response.data.FileName;

            if ('EOXRecord' in response.data){
              this.EOXRecord = response.data.EOXRecord;
              this.PaginationResponseRecord = response.data.PaginationResponseRecord;

              let rec;
              for (rec in this.EOXRecord){
                let data = {
                  EOLProductID: this.EOXRecord[rec].EOLProductID,
                  ProductIDDescription: this.EOXRecord[rec].ProductIDDescription,
                  EOXExternalAnnouncementDate: this.EOXRecord[rec].EOXExternalAnnouncementDate.value,
                  EndOfSaleDate:	this.EOXRecord[rec].EndOfSaleDate.value,
                  EndOfSWMaintenanceReleases: this.EOXRecord[rec].EndOfSWMaintenanceReleases.value,
                  EndOfSecurityVulSupportDate: this.EOXRecord[rec].EndOfSecurityVulSupportDate.value,
                  EndOfRoutineFailureAnalysisDate: this.EOXRecord[rec].EndOfRoutineFailureAnalysisDate.value,
                  EndOfServiceContractRenewal: this.EOXRecord[rec].EndOfServiceContractRenewal.value,
                  LastDateOfSupport: this.EOXRecord[rec].LastDateOfSupport.value,
                  EndOfSvcAttachDate: this.EOXRecord[rec].EndOfSvcAttachDate.value,
                  MigrationInformation:	this.EOXRecord[rec].EOXMigrationDetails.MigrationInformation,
                  MigrationOption: this.EOXRecord[rec].EOXMigrationDetails.MigrationOption,
                  MigrationProductId:	this.EOXRecord[rec].EOXMigrationDetails.MigrationProductId,
                  MigrationProductName: this.EOXRecord[rec].EOXMigrationDetails.MigrationProductName
                }
                this.EOXRecordTableData.push(data)
              }
            }
          }
        })
        .catch(() => this.notify('Ops, unexpected error. Please, try again later.', 'error'))
        .finally(() => {
          this.$q.loading.hide();
          // console.log(this.EOXRecordTableData)
        })
    },
    notify(message, icon = 'check') {
      this.$q.notify({ icon, position: 'top', message })
    },
    downloadFile(fileName){
      this.$axios({
        method: 'get',
        url: `/download/${fileName}`,
        responseType: 'arraybuffer'
      })
        .then(response => {

          this.forceFileDownload(response, fileName)

        })
        .catch(() => console.log('error occured'))
    },
    forceFileDownload(response, fileName){
      const url = window.URL.createObjectURL(new Blob([response.data]))
      const link = document.createElement('a')
      link.href = url
      link.setAttribute('download', fileName) //or any other extension
      document.body.appendChild(link)
      link.click()
    }
  }
}
</script>

<style lang="stylus">
  h1
    font-size 1.5rem
    line-height 2rem

  h2
    font-size 0.9rem
    line-height 2rem

  .actions
    margin-top 20px

  .info
    background-color rgb(247, 232, 236)

  .q-chip--dense
    font-size 14px
</style>
